'----------------------------------------------------------
' Programm initialisieren
'----------------------------------------------------------
$Regfile = "m8def.dat"           ' ATmega8-Deklarationen
$Crystal = 3686400               ' Taktfrequenz: 3,6864 MHz
Config LCD=20*4

'----------------------------------------------------------
' LCD-Zeichen Chr(0)
'----------------------------------------------------------
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 1   ' 00001
' 3   ' 00011
' 7   ' 00111
' 15  ' 01111
DefLCDChar 0, 0,0,0,0,1,3,7,15

'----------------------------------------------------------
' LCD-Zeichen Chr(1)
'----------------------------------------------------------
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
DefLCDChar 1, 0,0,0,0,31,31,31,31

'----------------------------------------------------------
' LCD-Zeichen Chr(2)
'----------------------------------------------------------
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 16  ' 10000
' 24  ' 11000
' 28  ' 11100
' 30  ' 11110
DefLCDChar 2, 0,0,0,0,16,24,28,30

'----------------------------------------------------------
' LCD-Zeichen Chr(3)
'----------------------------------------------------------
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
' 30  ' 11110
' 28  ' 11100
' 24  ' 11000
' 16  ' 10000
DefLCDChar 3, 31,31,31,31,30,28,24,16

'----------------------------------------------------------
' LCD-Zeichen Chr(4)
'----------------------------------------------------------
' 16  ' 10000
' 24  ' 11000
' 28  ' 11100
' 30  ' 11110
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
DefLCDChar 4, 16,24,28,30,31,31,31,31

'----------------------------------------------------------
' LCD-Zeichen Chr(5)
'----------------------------------------------------------
' 15  ' 01111
' 7   ' 00111
' 3   ' 00011
' 1   ' 00001
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
DefLCDChar 5, 15,7,3,1,0,0,0,0

'----------------------------------------------------------
' LCD-Zeichen Chr(6)
'----------------------------------------------------------
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
' 31  ' 11111
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
DefLCDChar 6, 31,31,31,31,0,0,0,0

'----------------------------------------------------------
' LCD-Zeichen Chr(7)
'----------------------------------------------------------
' 30  ' 11110
' 28  ' 11100
' 24  ' 11000
' 16  ' 10000
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
' 0   ' 00000
DefLCDChar 7, 30,28,24,16,0,0,0,0

Cls                                             ' CLS nach dem DefLCDChar ist wichtig !! (LCD-Controller wird in den Datenmodus zurckgesetzt)

Declare Sub LCDBig                              ' Funktion zum Schreiben der groen Zahlen deklarieren
Dim LCDBigSpalte As Byte, LCDBigZahl As Byte    ' Variablen fr LCDBig (bentigt weniger Ressourcen wie eine Parameterbergabe an LCDBig)

'----------------------------------------------------------
' Hauptschleife
'----------------------------------------------------------
Do
  ' Beispielanzeige Uhrzeit:
  Cls
  LCDBigSpalte = 2:  LCDBigZahl = 2: LCDBig
  LCDBigSpalte = 6:  LCDBigZahl = 3: LCDBig
  LCDBigSpalte = 12: LCDBigZahl = 1: LCDBig
  LCDBigSpalte = 16: LCDBigZahl = 5: LCDBig
  Locate 2,10: LCD Chr(111)
  Locate 3,10: LCD Chr(111)
  Wait 1

  ' Beispielanzeige LCD-Helligkeit:
  Cls
  Locate 2,1: LCD "LCD-"
  Locate 3,1: LCD "Helligkeit:"
  LCDBigSpalte = 12: LCDBigZahl = 1: LCDBig
  LCDBigSpalte = 15: LCDBigZahl = 0: LCDBig
  LCDBigSpalte = 18: LCDBigZahl = 0: LCDBig
  Wait 1
Loop

'----------------------------------------------------------
' LCDBig: Funktion zum Schreiben der Zahlen zum LCD
'----------------------------------------------------------
Sub LCDBig
  ' Zeile 1
  Locate 1,LCDBigSpalte
  Select Case LCDBigZahl
    Case 0: LCD Chr(0);Chr(1);Chr(2)
    Case 1: LCD Chr(0);Chr(1);Chr(32)
    Case 2: LCD Chr(0);Chr(1);Chr(2)
    Case 3: LCD Chr(0);Chr(1);Chr(2)
    Case 4: LCD Chr(1);Chr(32);Chr(32)
    Case 5: LCD Chr(1);Chr(1);Chr(1)
    Case 6: LCD Chr(0);Chr(1);Chr(2)
    Case 7: LCD Chr(1);Chr(1);Chr(1)
    Case 8: LCD Chr(0);Chr(1);Chr(2)
    Case 9: LCD Chr(0);Chr(1);Chr(2)
  End Select

  ' Zeile 2
  Locate 2,LCDBigSpalte
  Select Case LCDBigZahl
    Case 0: LCD Chr(255);Chr(32);Chr(255)
    Case 1: LCD Chr(32);Chr(255);Chr(32)
    Case 2: LCD Chr(0);Chr(1);Chr(3)
    Case 3: LCD Chr(32);Chr(0);Chr(3)
    Case 4: LCD Chr(255);Chr(1);Chr(255)
    Case 5: LCD Chr(255);Chr(1);Chr(2)
    Case 6: LCD Chr(255);Chr(1);Chr(2)
    Case 7: LCD Chr(32);Chr(0);Chr(3)
    Case 8: LCD Chr(255);Chr(1);Chr(255)
    Case 9: LCD Chr(255);Chr(1);Chr(255)
  End Select

  ' Zeile 3
  Locate 3,LCDBigSpalte
  Select Case LCDBigZahl
    Case 0: LCD Chr(255);Chr(32);Chr(255)
    Case 1: LCD Chr(32);Chr(255);Chr(32)
    Case 2: LCD Chr(255);Chr(32);Chr(32)
    Case 3: LCD Chr(32);Chr(5);Chr(4)
    Case 4: LCD Chr(32);Chr(32);Chr(255)
    Case 5: LCD Chr(32);Chr(32);Chr(255)
    Case 6: LCD Chr(255);Chr(32);Chr(255)
    Case 7: LCD Chr(32);Chr(255);Chr(32)
    Case 8: LCD Chr(255);Chr(32);Chr(255)
    Case 9: LCD Chr(32);Chr(32);Chr(255)
  End Select

  ' Zeile 4
  Locate 4,LCDBigSpalte
  Select Case LCDBigZahl
    Case 0: LCD Chr(5);Chr(6);Chr(7)
    Case 1: LCD Chr(6);Chr(6);Chr(6)
    Case 2: LCD Chr(6);Chr(6);Chr(6)
    Case 3: LCD Chr(5);Chr(6);Chr(7)
    Case 4: LCD Chr(32);Chr(32);Chr(6)
    Case 5: LCD Chr(6);Chr(6);Chr(7)
    Case 6: LCD Chr(5);Chr(6);Chr(7)
    Case 7: LCD Chr(32);Chr(6);Chr(32)
    Case 8: LCD Chr(5);Chr(6);Chr(7)
    Case 9: LCD Chr(5);Chr(6);Chr(7)
  End Select
End Sub